#include <mes2.h>
#include <h8/reg770x.h>

#define IPRA_TMU0_MASK	0xf000
#define IPRA_TMU1_MASK	0x0f00
#define IPRA_TMU2_MASK	0x00f0
#define IPRA_TMU0_1	0x1000
#define IPRA_TMU1_1	0x0100
#define IPRA_TMU2_1	0x0010
#define	TSTR_TMU0	0x01
#define	TSTR_TMU1	0x02
#define	TSTR_TMU2	0x04
#define	TCR_UNF		0x0100

#define VECTOR_TUNI0	0x400
#define VECTOR_TUNI1	0x420
#define VECTOR_TUNI2	0x440


#define 	ESIO_PA_DATA	(*(volatile unsigned char *)0xb0000000)
#define 	ESIO_PA_IER		(*(volatile unsigned char *)0xb0000001)
#define 	ESIO_PA_IIR		(*(volatile unsigned char *)0xb0000002)
#define 	ESIO_PA_LCR		(*(volatile unsigned char *)0xb0000003)
#define 	ESIO_PA_MCR		(*(volatile unsigned char *)0xb0000004)
#define 	ESIO_PA_LSR		(*(volatile unsigned char *)0xb0000005)
#define 	ESIO_PA_MSR		(*(volatile unsigned char *)0xb0000006)
#define 	ESIO_PA_DLL		(*(volatile unsigned char *)0xb0000000)
#define 	ESIO_PA_DLM		(*(volatile unsigned char *)0xb0000001)

#define 	ESIO_PB_DATA	(*(volatile unsigned char *)0xb0000008)
#define 	ESIO_PB_IER		(*(volatile unsigned char *)0xb0000009)
#define 	ESIO_PB_IIR		(*(volatile unsigned char *)0xb000000a)
#define 	ESIO_PB_LCR		(*(volatile unsigned char *)0xb000000b)
#define 	ESIO_PB_MCR		(*(volatile unsigned char *)0xb000000c)
#define 	ESIO_PB_LSR		(*(volatile unsigned char *)0xb000000d)
#define 	ESIO_PB_MSR		(*(volatile unsigned char *)0xb000000e)
#define 	ESIO_PB_DLL		(*(volatile unsigned char *)0xb0000008)
#define 	ESIO_PB_DLM	 	(*(volatile unsigned char *)0xb0000009)




//IRQ1 IPRC(7-4) 
//IRQ3 IPRC(15-12) 

#define IPRC_IRQ1_MASK	0x00f0
#define IPRC_IRQ3_MASK	0xf000
#define IPRC_IRQ1_1	0x0010
#define IPRC_IRQ3_1	0x1000


#define VECTOR_IRQ1	 	0x620
#define VECTOR_IRQ3	 	0x660

//SCI0 IPRB(7-4) 
#define IPRB_SCI0_MASK	0x00f0
#define IPRB_SCI0_1		0x0010

#define VECTOR_ERI0	 	0x4e0
#define VECTOR_RXI0	 	0x500
#define VECTOR_TXI0	 	0x520

//CPLD
#define XPA	(*(volatile unsigned char *)0xb0008010)
#define XPB	(*(volatile unsigned char *)0xb0008012)
#define XPC	(*(volatile unsigned char *)0xb0008014)
#define XPD	(*(volatile unsigned char *)0xb0008016)
#define XCW	(*(volatile unsigned char *)0xb0008018)

//T104-DIO72 BASE 0x320
#define DPA1  (*(volatile unsigned char *)0xb8000320)
#define DPB1  (*(volatile unsigned char *)0xb8000321)
#define DPC1  (*(volatile unsigned char *)0xb8000322)
#define DPW1  (*(volatile unsigned char *)0xb8000323)

#define DPA2  (*(volatile unsigned char *)0xb8000324)
#define DPB2  (*(volatile unsigned char *)0xb8000325)
#define DPC2  (*(volatile unsigned char *)0xb8000326)
#define DPW2  (*(volatile unsigned char *)0xb8000327)

#define DPA3  (*(volatile unsigned char *)0xb8000328)
#define DPB3  (*(volatile unsigned char *)0xb8000329)
#define DPC3  (*(volatile unsigned char *)0xb800032a)
#define DPW3  (*(volatile unsigned char *)0xb800032b)

//T104-O64 BASE 0x300
#define OPA1  (*(volatile unsigned char *)0xb8000300)
#define OPB1  (*(volatile unsigned char *)0xb8000301)
#define OPC1  (*(volatile unsigned char *)0xb8000302)
#define OPD1  (*(volatile unsigned char *)0xb8000303)
#define OPE1  (*(volatile unsigned char *)0xb8000304)
#define OPF1  (*(volatile unsigned char *)0xb8000305)
#define OPG1  (*(volatile unsigned char *)0xb8000306)
#define OPH1  (*(volatile unsigned char *)0xb8000307)


// 荞݃nh
void int_timer(void)    __attribute__((interrupt_handler, nosave_low_regs));
void int_16C752_a(void) __attribute__((interrupt_handler, nosave_low_regs));
void int_16C752_b(void) __attribute__((interrupt_handler, nosave_low_regs));
void int_eri0(void)     __attribute__((interrupt_handler, nosave_low_regs));
void int_rxi0(void)     __attribute__((interrupt_handler, nosave_low_regs));
void int_txi0(void)     __attribute__((interrupt_handler, nosave_low_regs));

short inbuf1;
short inbuf2;
short inbuf3;

short cnt;
int sft_cnt;
int cnt64;

unsigned long led_data;

void int_eri0(void){
	  SSR0 &= 0xc7 ;	/* Clear receive error flag	*/
}
void int_rxi0(void){
	//unsigned char c;
	
	/* 1M */
  	inbuf3 = RDR0 ;		/* Get receive data		*/
    SSR0 &= ~0x40 ;		/* Clear receive data flag	*/
	
	
//  	TDR0 = c ;		/* Set transmit data			*/
//  	SSR0 &=  ~0x80;	/* Transmit				*/
}
void int_txi0(void){
}


void int_16C752_a(void){
	volatile char int_id;
	
	IRR0 &= ~0x8; //Clr IRQ3 
	
	while(1){
		int_id = ESIO_PA_IIR;
		if ((int_id & 1) == 1 ){//no pending ?
			break;
		}
		if (int_id >= 4){//RHR ?
			inbuf1 = ESIO_PA_DATA;	/* store into buffer */
		}
	}
}
void int_16C752_b(void){
	volatile char int_id;
	
	IRR0 &= ~0x2; //Clr IRQ1 
	
	while(1){
		int_id = ESIO_PB_IIR;
		if ((int_id & 1) == 1 ){//no pending ?
			break;
		}
		if (int_id >= 4){//RHR ?
			inbuf2 = ESIO_PB_DATA;	/* store into buffer */
		}
	}
}

void int_timer(void) {
	// LED_Ԃ𔽓]
	SCPDR ^= 0x10; //LED1
	
	PDDR ^= 0x2; //LED2
	
	PDDR ^= 0x80; //LED3
	
	
	// MTU`lx̃Xe[^XNA
	TCR_2 &= ~TCR_UNF;
	
//	if(++cnt > 0){
//		cnt = 0;
		if(++sft_cnt > 31) sft_cnt = 0;
		
		led_data = (1 << sft_cnt);
//	};

//	XPA = led_data & 0x000000ff;
//	XPB = (led_data & 0x0000ff00) >> 8;
//	XPC = (led_data & 0x00ff0000) >> 16;
//	XPD = (led_data & 0xff000000) >> 24;
	
	if(PGDR & 0x10){ //SW1
		XPA <<= 1;
		if(XPA == 0) XPA = 1;
	}
	else{
		XPA = (PEDR >> 4);
	}
	
	XPB <<= 1;
	if(XPB == 0) XPB = 1;
	XPC <<= 1;
	if(XPC == 0) XPC = 1;
	XPD <<= 1;
	if(XPD == 0) XPD = 1;

	//T104-DIO72
	DPA1 <<= 1;
	if(DPA1 == 0) DPA1 = 1;
	DPB1 <<= 1;
	if(DPB1 == 0) DPB1 = 1;
	DPC1 <<= 1;
	if(DPC1 == 0) DPC1 = 1;

	//T104-O64
	OPA1 <<= 1;
	OPB1 <<= 1;
	OPC1 <<= 1;
	OPD1 <<= 1;
	
	OPE1 <<= 1;
	OPF1 <<= 1;
	OPG1 <<= 1;
	OPH1 <<= 1;
	if(++cnt64 > 31) cnt64 = 0;
	
	if(cnt64 == 0)  OPA1 = 1;
	if(cnt64 == 8)  OPB1 = 1;
	if(cnt64 == 16) OPC1 = 1;
	if(cnt64 == 24) OPD1 = 1;
	
	if(cnt64 == 0)  OPE1 = 1;
	if(cnt64 == 8)  OPF1 = 1;
	if(cnt64 == 16) OPG1 = 1;
	if(cnt64 == 24) OPH1 = 1;
	
	
/*
	OPA1 = led_data & 0x000000ff;
	OPB1 = (led_data & 0x0000ff00) >> 8;
	OPC1 = (led_data & 0x00ff0000) >> 16;
	OPD1 = (led_data & 0xff000000) >> 24;
*/
	
}
void init_tmu2(void){
	// xN^4x0Ԃ̊荞݃nho^
	set_handler(VECTOR_TUNI2, int_timer);

	// TMU`lx荞݂̗D揇ʂ1ɐݒ
	IPRA &= ~IPRA_TMU2_MASK;
	IPRA |= IPRA_TMU2_1;
	// VXeNbN256ŃJEg/TMU`lx̊荞݋
	TCR_2 = 0x0023;
	// 1b 1/32768000b(32.768MHz) X 256 X 12800 = 0.1b
	TCOR_2 = 12800;
	TCNT_2 = 12800;
	// TMU`lxN
	TSTR |= TSTR_TMU2;
}
void init_ex_sio(void){
	char dmy;
	
	ESIO_PA_MCR = 0; // RTS,DTR=0
	ESIO_PA_LCR = 0x80; // {[[gݒ DLAB latch
	ESIO_PA_DLL = 10;  // {[[gݒ 8rbg 18.432MHz / 16 / 115200
	ESIO_PA_DLM = 00;  // {[[gݒ 8rbg 
	ESIO_PA_LCR = 0x03;  // 8 bit 
	ESIO_PA_IER = 0;  // disable interrupt  
	ESIO_PA_MCR = 0x03;  // DTR,RTS=ON 
	
	ESIO_PB_MCR = 0; // RTS,DTR=0
	ESIO_PB_LCR = 0x80; // {[[gݒ DLAB latch
	ESIO_PB_DLL = 10;  // {[[gݒ 8rbg 18.432MHz / 16 / 115200
	ESIO_PB_DLM = 00;  // {[[gݒ 8rbg 
	ESIO_PB_LCR = 0x03;  // 8 bit 
	ESIO_PB_IER = 0;  // disable interrupt  
	ESIO_PB_MCR = 0x03;  // DTR,RTS=ON 
	
	dmy = ESIO_PA_IIR ; // clear intr flag 
	dmy = ESIO_PA_DATA; // clear buffer 

	dmy = ESIO_PB_IIR ; // clear intr flag 
	dmy = ESIO_PB_DATA; // clear buffer 

	
	// xN^荞݃nho^
	set_handler(VECTOR_IRQ3, int_16C752_a);
	set_handler(VECTOR_IRQ1, int_16C752_b);

	// 荞݂̗D揇ʂ1ɐݒ
	IPRC &= ~IPRC_IRQ3_MASK;
	IPRC |= IPRC_IRQ3_1;
	
	IPRC &= ~IPRC_IRQ1_MASK;
	IPRC |= IPRC_IRQ1_1;
	
	ESIO_PA_IER = 0x01; // Enable interrupt Receive data  
	ESIO_PA_MCR = 0x0b; // set modem control register,only set out2 to enable interrupt 
	ESIO_PB_IER = 0x01; // Enable interrupt Receive data  
	ESIO_PB_MCR = 0x0b; // set modem control register,only set out2 to enable interrupt 
	
}
void init_sci0(void){
  	unsigned int dmy ;

  	SCR0 = 0 ;		/* Stop SCI0 , internal clock use	*/
  	SMR0 = 0 ;		/* Asynchronous mode ,8data,1stop,no-parity */
  	BRR0 = 8 ;			/* 115200 --1.234567901% 32.768MHz */
  	for( dmy = 1000 ; dmy > 0 ; dmy--) ;	/* Wait 1bit transfer time	*/
  	//SCR0 = 0x30 ;	/* Enable Tx & Rx , 	*/
  	SCR0 = 0x70 ;	/* int rx Enable Tx & Rx , 	*/
  	SSR0 &= 0x80 ;	/* Clear receive error flag(ORER,FER,PER)  */
	
	// xN^荞݃nho^
	set_handler(VECTOR_ERI0, int_eri0);
	set_handler(VECTOR_RXI0, int_rxi0);
	set_handler(VECTOR_TXI0, int_txi0);

	// 荞݂̗D揇ʂ1ɐݒ
	IPRB &= ~IPRB_SCI0_MASK;
	IPRB |= IPRB_SCI0_1;
	
}
int main() {
	char data;
	char c;
	
	XCW = 0xf; //all out

	XPA = 0xff;
	XPB = 0xff;
	XPC = 0xff;
	XPD = 0xff;
	
	DPA1 = 0xff;
	DPB1 = 0xff;
	DPC1 = 0xff;
	
	
	DPW1 = 0x80; //T104-DIO72 All Out
	DPW2 = 0x80; //T104-DIO72 All Out
	DPW3 = 0x80; //T104-DIO72 All Out

	init_tmu2();
	init_ex_sio();
	init_sci0();
	
	inbuf1 = -1;
	inbuf2 = -1;
	inbuf3 = -1;
	
	
	
	// [v
	while(!read(0, &c, 1)){
		
		if(inbuf1 > 0){
			while( (ESIO_PA_LSR  &  0x20) == 0 ) ;  // Mobt@ ?
			ESIO_PA_DATA = inbuf1; // send
			inbuf1 = -1;
		}
		if(inbuf2 > 0){
			while( (ESIO_PB_LSR  &  0x20) == 0 ) ;  // Mobt@ ?
			ESIO_PB_DATA = inbuf2; // send
			inbuf2 = -1;
		}
		if(inbuf3 > 0){
  			while(!(SSR0 & 0x80) ) ;	/* Wait transmit data register empty	*/
  			TDR0 = inbuf3 ;		/* Set transmit data			*/
  			SSR0 &= ~0x80;	/* Transmit				*/
			inbuf3 = -1;
		}
		//
		printf(" cnt64 = %d %2X %2X %2X %2X  \r",cnt64,OPA1,OPB1,OPC1,OPD1);
		
	}
	
	/*
	// [v
	for(;;){
		if( ESIO_PA_LSR & 0x01 ){
			data = ESIO_PA_DATA;
			while( (ESIO_PA_LSR  &  0x20) == 0 ) ;  // Mobt@ ?
			ESIO_PA_DATA = data; // send
		}
		if( ESIO_PB_LSR & 0x01 ){
			data = ESIO_PB_DATA;
			while( (ESIO_PB_LSR  &  0x20) == 0 ) ;  // Mobt@ ?
			ESIO_PB_DATA = data; // send
		}
	}
	*/
	
	// TMU`lx荞݂̗D揇ʂ0ɐݒ
	IPRA &= ~IPRA_TMU2_MASK;
	IPRB &= ~IPRB_SCI0_MASK;
	IPRC &= ~IPRC_IRQ3_MASK;
	IPRC &= ~IPRC_IRQ1_MASK;
	
	
	
	
fin:;
}
