//#include <macro.h>
#include <mes2.h>
//#include <string.h>

#include <h8/reg770x.h>
//#include "iodefine.h"

#define BIT_0 	(1 << 0)
#define BIT_1 	(1 << 1)
#define BIT_2 	(1 << 2)
#define BIT_3 	(1 << 3)
#define BIT_4 	(1 << 4)
#define BIT_5 	(1 << 5)
#define BIT_6 	(1 << 6)
#define BIT_7 	(1 << 7)
#define BIT_8 	(1 << 8)
#define BIT_9 	(1 << 9)
#define BIT_10 	(1 << 10)
#define BIT_11 	(1 << 11)
#define BIT_12	(1 << 12)
#define BIT_13	(1 << 13)
#define BIT_14	(1 << 14)
#define BIT_15 	(1 << 15)

// MP3 I/O Ports
#define	MP3_DREQ	( PFDR & BIT_3 )		// DREQ

#define	MP3_XDCS_H	( PFDR |=  BIT_2 )		// xDCS
#define	MP3_XDCS_L	( PFDR &= ~BIT_2 )		// xDCS

#define	MP3_XCS_H	( PFDR |=  BIT_1 )		// xCS
#define	MP3_XCS_L	( PFDR &= ~BIT_1 )		// xCS

#define	MP3_XRESET_H	( PFDR |=  BIT_4 )		// xRESET
#define	MP3_XRESET_L	( PFDR &= ~BIT_4 )		// xRESET

#define SPI1_DATA	(*(volatile unsigned char *)0xb0008008)
#define SPI1_STS	(*(volatile unsigned char *)0xb000800a)
#define SPI1_BLK	(*(volatile unsigned char *)0xb000800c)

#define DIV_C	(*(volatile unsigned char *)0xb000801a)

//CPLD
#define XPA	(*(volatile unsigned char *)0xb0008010)
#define XPB	(*(volatile unsigned char *)0xb0008012)
#define XPC	(*(volatile unsigned char *)0xb0008014)
#define XPD	(*(volatile unsigned char *)0xb0008016)
#define XCW	(*(volatile unsigned char *)0xb0008018)


int MP3Putc(char c) {
	int x = 0;
	
	while(!(SPI1_STS & 0x80));
	SPI1_DATA = c;
//	while(!(SPI1_STS & 0x80));
//	x = SPI1_DATA;
	return x;
}
// PoCgWX^
void MP3RegWrite( int adrs, int data ) {

	int i, dmy;

	MP3_XCS_L;						// xCS Active
	MP3Putc( 0x02 );
	MP3Putc( adrs );
	MP3Putc( data / 256 );
	MP3Putc( data % 256 );
	while(!(SPI1_STS & 0x80));
	MP3_XCS_H;						// xCS Negate

}
void init_io(void){
	//VS1053
	
	MP3_XCS_H;     //PF1 High XCS    VS1053
	MP3_XDCS_H;    //PF2 High XDCS   VS1053
	MP3_XRESET_H;  //PF4 High XRESET VS1053
	
	XCW = 0xf; //All out

	DIV_C = 0x0; //SPI CLK 65.536 / 32 2.048MHz
//	DIV_C = 0x1; //SPI CLK 65.536 / 16 4.096MHz
//	DIV_C = 0x2; //SPI CLK 65.536 / 8  8.192MHz
//	DIV_C = 0x3; //SPI CLK 65.536 / 4 16.384MHz
	
//	printf("mp init io \r");
	
//	PFC.PFCR.BIT.PF4MD = 1; //PF4 out for XRESET VS1053
//	PFC.PFCR.BIT.PF3MD = 2; //PF3 in  for DREQ   VS1053
//	PFC.PFCR.BIT.PF1MD = 1; //PF1 out for XCS    VS1053
//	PFC.PFCR.BIT.PF2MD = 1; //PF2 out for XDCS   VS1053
	
//	printf("mp init io2 \r");
	
	//EEPROM AT25320A 
//	PD.DR.BIT.B6 = 1;//PD6 High _CS AT23320A
//	PFC.PDCR.BIT.PD6MD = 1; //PD6 out for _CS AT23320A
	
//	printf("mp init io3 \r");
}
// MP3fR[_
void init_VLSI(){
	int	i, x;

/*
	MP3_XRESET_L;
	
	for ( i=0; i<10000; i++ )
		x = MP3_DREQ;					// 2usȏwait
	
	MP3_XRESET_H;
*/

	MP3_XDCS_H;						// BSYNC(xDCS)="H"
	MP3_XCS_L;						// xCS Negate

	while( MP3_DREQ == 0 );				// DREQ Check

	MP3RegWrite( 0, 0x0004 );			// Software Reset

	for ( i=0; i<1000; i++ )
		x = MP3_DREQ;					// 2usȏwait

	MP3RegWrite( 0, 0x0000 );			// Software Reset 

	while( MP3_DREQ == 0 );				// DREQ Check

	MP3RegWrite( 0, 0x0800 );			// SM_SDINEW,SM_SDISHARE,LOUDNESS
//	MP3RegWrite( 0, 0x08a0 );			// SM_SDINEW,SM_SDISHARE,LOUDNESS
	MP3RegWrite( 0x03, 0xa000 );		// x4 12.288MHz
//	MP3RegWrite( 0x03, 0x8000 + (int)((12288000) / 2000) );		// 12.288MHz
//	MP3RegWrite( 0x0B, 0x3838 );		// Volime EƂ0x10
//	MP3RegWrite( 0x0a, 0x4022 );			// Sweep test

	DIV_C = 0x2; //SPI CLK 65.536 / 8  8.192MHz
//	DIV_C = 0x3; //SPI CLK 65.536 / 4 16.384MHz

}
void MP3Trans(char c){
	while( MP3_DREQ == 0 );				// DREQ Check
	MP3Putc(c);
}


int main(int argc, char **argv) {
	unsigned short	data[8], verify[8], i;
	unsigned int	n;
	char c;
	int vol = 0xb0;
	int vol_i;

	int fd;
	char	*name;
	char	buf[256];


//		SCP.DR.BYTE |= 0x10;
//		SCP.DR.BIT.B4 = 0;
//		SCP.DR.BIT.B4 = 1;



//0x53C0xEFC0x6EC0xe4C0C0C0C0D


	init_io();
	
	init_VLSI();

	
	//printf("argc = %d \n",argc);
	if(argc != 2){
		printf("Err! \n");
		return -1;
	}
	//name = cwd();
	//strcat(name,argv[1]);
	
//rpt:;
	
	fd = open(argv[1], OptRead);
	
	printf("name = %s  \n",argv[1]);
	if(fd == -1){
		printf("Open Error! \n");
		return -1;
	}
	
	
	vol_i = (~(vol << 8) & 0xff00 ) | (~vol & 0xff);
	MP3RegWrite( 0x0B, vol_i   );		// Volime
	
	
	
	
	MP3_XDCS_L;				// xDCS Negate

//	MP3Trans(0x53);
//	MP3Trans(0xef);
//	MP3Trans(0x6e);
//	MP3Trans(0xe6);
//	MP3Trans(0x0);
//	MP3Trans(0x0);
//	MP3Trans(0x0);
//	MP3Trans(0x0);
	
	

	while(1){
	
		if(MP3_DREQ){
			if(read(fd, buf, 256) == 0){//file end?
//			if(read(fd, buf, 1) == 0){//file end?
				close(fd);
				break;
			}
			for(i=0;i<256;i++){
//			for(i=0;i<1;i++){
				//MP3Putc(buf[i]);
				MP3Trans(buf[i]);
				//printf("%02X ",buf[i]);
			}
		}
		
		if( !(PGDR & 0x10) ){ //SW1
			break;
		}
	
	
	
		if(read(0, &c, 1) ){
			if(c == 'q'){
				break;
			}
			else if(c == 'u'){
				if(++vol > 0xff ){
					vol = 0xff;
				}
				vol_i = (~(vol << 8) & 0xff00 ) | (~vol & 0xff);
				
				MP3_XDCS_H;				// xDCS Negate
				MP3RegWrite( 0x0B, vol_i   );		// Volime
				printf("vol = %X \r",vol);
				MP3_XDCS_L;				// xDCS Negate
				
			}
			else if(c == 'd'){
				if(--vol < 1 ){
					vol = 1;
				}
				vol_i = (~(vol << 8) & 0xff00 ) | (~vol & 0xff);
				MP3_XDCS_H;				// xDCS Negate
				MP3RegWrite( 0x0B, vol_i   );		// Volime
				MP3_XDCS_L;				// xDCS Negate
				printf("vol = %X \r",vol);
			}
		}
	}
	close(fd);
	

	printf("\r");
	
	
//	goto rpt;
	
	
fin:;
}
